package ObserverPattern;

/**
 * this is the implementation of observer
 * @author cliu3
 *
 */
public class SMSUsers implements Observer{

	private final CommentaryObject subject; // the corresponding subject
	private String updates;
	private String userInfo;// basic user information
	
	// construction, subject+ user informaiton
	public SMSUsers(CommentaryObject subject,String userInfo){
		if(subject==null){
			throw new IllegalArgumentException("No Publisher found.");
		}
		this.subject = subject;
		this.userInfo = userInfo;
	}
	
	// updates 
	@Override
	public void update(String updates) {
		this.updates = updates;
		display();
	}
	
	// report the updates information from subject. 
	private void display(){
		System.out.println("["+userInfo+"]: "+updates);
	}
	
	@Override
	public void subscribe() {
		//System.out.println("Subscribing "+userInfo+" to "+subject.subjectDetails()+" ...");
		this.subject.subscribeObserver(this);
		System.out.println("Subscribed successfully.");
	}

	@Override
	public void unSubscribe() {
		//System.out.println("Unsubscribing "+userInfo+" to "+subject.subjectDetails()+" ...");
		this.subject.unSubscribeObserver(this);
		System.out.println("Unsubscribed successfully.");
	}

}
